
import os

# This is sent with every message. X-Mailer:
ver_string = "Pyne 1.1.0 (%s)"
ver_stamp = (1,0,0)
# complete the pyne version string: host OS
os_info = os.uname()[0]
ver_string = ver_string % os_info.strip()

HPANE_POS = 2
VPANE_POS = 3

#### User options
# mark messages as read only when double-clicked
OPT_2CLICK_MARK   = 0x1
# 'classic' pane configuration
#OPT_PANES_CLASSIC = 0x2
# use external editor
OPT_EXT_EDITOR    = 0x4
OPT_NO_QUICKVIEW_NNTP = 0x10
OPT_NO_QUICKVIEW_MAIL = 0x20

# User interface types (user.ui_style)
UI_DEFAULT	= 0
UI_CLASSIC	= 1
UI_TABBED	= 2

# user.act_flags.  Mostly used to mark some operation desired to be performed
ACT_UPDATE	= 0x1
# Mail collection policies
# (what to do with the message on the server once it has been collected)
SERVER_DELETE	= 0
SERVER_LEAVE	= 1
SERVER_EXPIRE	= 2 # requires 'days' argument

server_policies = [ "Delete from server", "Leave on server", "Expire after (days)" ]

# Message header tuple indices
HEAD_DATE = 0
HEAD_DATE_RECEIVED = 1
HEAD_MESSAGE_ID = 2
HEAD_REFERENCES = 3
HEAD_SUBJECT = 4
HEAD_FROM_TO = 5
HEAD_OPTS = 6
HEAD_SENDUID = 7
HEAD_LENGTH = 8 # size of header tuple (ab)used by threading code :)

# Reply types
REPLY_EMAIL	= 0	# to email account
REPLY_GROUP	= 1	# to newsgroup
REPLY_CC	= 3	# to all Cc'd mailboxes
REPLY_FORWARD	= 4	# forward to mailbox
REPLY_AUTO	= 5	# chose the most apropriate reply type:
			#   to group if nntp reply
			#   to sender if mail reply

# message list filters.
FILTER_READ	= 0x1
FILTER_UNREAD	= 0x2
FILTER_PARTIAL	= 0x4
FILTER_FULL	= 0x8
FILTER_UNMARKED	= 0x10
FILTER_MARKED	= 0x20

# message.opts. 32-bits:
MSG_ISREAD    = 0x00000001 # is read?
MSG_ISREPLIED = 0x00000002 # is replied to?
MSG_NO_BODY   = 0x00000004 # only header collected?
MSG_ISMARKED  = 0x00000008 # is marked?
MSG_SENT      = 0x00000010 # has been sent.
# outgoing messages. options
#MSG_GETRECEPT = 0x00000010 # request confirmation of delivery

# boundary used in multi-part messages
multi_part_boundary = "pyneboundaryMSPGTGATSTHBEMGTIMTTMYKYE"

